<template>
    <div class="row" v-if="match">
        <template>
            <div class="cell cell-datetime">
                <div class="icon icon-finished" v-if="isFinished"></div>
                <div class="icon icon-playing" v-if="isPlay"></div>
                <div class="text" :class="[isPlay ? 'red': '']">{{ startTime }}</div>
            </div>
            <router-link
                :to="`/football/match/${match.event_id}`"
                class="cell cell-team"
            >
                <div class="item">
                    <span
                        class="team-logo"
                        :style="{ backgroundImage: teamLogo(match.participants[0]) }"
                    ></span>
                    <div
                        class="team-name"
                        :class="
                        [winnerTeam && winnerTeam === 1 ? 'team-winner': winnerTeam && winnerTeam === 2 ? 'team-lose' : '']
                        "
                    >{{ match.participants[0].participant_name }}</div>
                </div>
                <div class="item">
                    <span
                        class="team-logo"
                        :style="{ backgroundImage: teamLogo(match.participants[1]) }"
                    ></span>
                    <div
                        class="team-name"
                        :class="[winnerTeam && winnerTeam === 2  ? 'team-winner': winnerTeam && winnerTeam === 1 ? 'team-lose' : '']"
                    >{{ match.participants[1].participant_name }}</div>
                </div>
            </router-link>
            <div class="cell cell-score">
                <span class="bubble" :class="[isPlay ? 'bubble-red': '']" v-if="match.score">
                <span :class="
                        [winnerTeam && winnerTeam === 1 && isPlay ? 'team-winner red' : winnerTeam && winnerTeam === 1 ? 'team-winner': winnerTeam && winnerTeam === 2 ? 'team-lose' :  isPlay ? 'red': ' ']">
                    {{parseInt(this.match.score.split(':')[0])}}
                </span> :
                    <span :class="[winnerTeam && winnerTeam === 2 && isPlay ? 'team-winner red' : winnerTeam && winnerTeam === 2 ? 'team-winner' : winnerTeam && winnerTeam === 1 ? 'team-lose' :  isPlay ? 'red': ' ']">
                        {{parseInt(this.match.score.split(':')[1])}}
                    </span>
                </span>
            </div>
            <div class="cell cell-one">
                <span
                    v-if="bets"
                    class="bubble"
                    @click="addToTracker('1')"
                >{{ betOne }}</span>
            </div>
            <div class="cell cell-x">
                <span
                    v-if="bets"
                    class="bubble"
                    @click="addToTracker('X')"
                >{{ betX }}</span>
            </div>
            <div class="cell cell-two">
                <span
                    v-if="bets"
                    class="bubble"
                    @click="addToTracker('2')"
                >{{ betTwo }}</span>
            </div>
            <router-link
                :to="`/football/match/${match.event_id}`"
                class="cell cell-play"
            >
                <span class="play-btn"></span>
            </router-link>
        </template>
    </div>
</template>

<script>
    import moment from 'moment'
    import Api from '../../../JokerApi'
    import { mapGetters, mapActions,mapMutations } from 'vuex'

    const api = new Api

    export default {
        name: 'LeagueMatch',
        props: {
            match: {
                type: [Array, Object],
                required: true
            },
            bets: {
                type: [Array, Object],
                default: () => {}
            }
        },
        computed: {
            ...mapGetters(['headerClockTime','headerClockTimezoneOffset','headerClockDate']),
            betOne() {
                return this.bets[this.match.event_id]?.prematch[1]?.[0].coefficients['1'].toFixed(2) || '-'
            },
            betX() {
                return this.bets[this.match.event_id]?.prematch[1]?.[0].coefficients['X'].toFixed(2) || '-'
            },
            betTwo() {
                return this.bets[this.match.event_id]?.prematch[1]?.[0].coefficients['2'].toFixed(2) || '-'
            },
            isFinished() {
                if(this.match.status === 'The event is finished.'){
                    return 1;
                }
                else{
                    return false;
                }
            },
            isPlay() {
                if(this.match.status === 'The event is live.'){
                    return 1;
                }
                else{
                    return false;
                }
            },

            startTime() {
                return moment(this.match.fixture_start_date, 'YYYY-MM-DDTHH:mm:ss').add(this.$store.getters.headerClockTimezoneOffset,'h').format('HH:mm')
            },

            toDayDateMatch() {
                if( moment(this.match.fixture_start_date) === moment()){
                    return true;
                }
            },
            winnerTeam() {
                const score = this.match.score
                if (!score || parseInt(score.split(':')[0]) === parseInt(score.split(':')[1])) {
                    return false
                } else if(parseInt(score.split(':')[0]) > parseInt(score.split(':')[1])) {
                    return 1
                } else if(parseInt(score.split(':')[0]) < parseInt(score.split(':')[1])) {
                    return 2
                }
            }
        },
        methods: {
            ...mapActions(['setAverage']),
            teamLogo(team) {

                if(team.image !==null){
                    return `url('${window.location.origin}/storage/${team.image}')`
                }
                if(team.team_image !==null){
                    return `url('${window.location.origin}/storage/${team.team_image}')`
                }
                    return  `url('${window.location.origin}/img/team_placeholder.svg')`;

            },
            addToTracker(type) {
                const remember_token = this.$cookies.get('api_remember_token')
                api.addTrackerItem(remember_token, this.match.event_id, '1', type).then((res) => {
                    this.$log.debug('addToTracker: type, this.match.event_id, res', type, this.match.event_id, res)
                    this.setAverage({
                        marketId: type,
                        average: this.bets[this.match.event_id].prematch[1][0].coefficients[type],
                        id: `${this.match.event_id}${1}${type}${null}`
                    })
                }).then(() => {
                    this.$root.$emit('updateTrackerItems')
                })
            }
        },
        watch: {
            bets() {
                // this.$log.debug('this.bets', this.bets)
            }
        },
        mounted() {
        }
    }
</script>

<style lang="scss" scoped>
    .cell {
        &-one, &-x, &-two {
            .bubble { cursor: pointer; }
        }
        &-team {
            text-decoration: none;
            color: inherit;
        }
    }
</style>
